using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;

namespace F43607
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private bool isDragging = false;
		private ChartRegion currentRegion = null;
		private double xmin;
		private double ymax;
		private double ymin;
		private double xmax;
		private Point chartAreaPointX;
		private Point chartAreaPointY;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.ToolTip toolTip1;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			InitializeControlSettings();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		private void InitializeControlSettings()
		{
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

			// Specify a ChartPalette:
			Color[] color = new Color[]{Color.FromArgb(185, 73,141,238), Color.FromArgb(185,247,179,78),Color.FromArgb(185,186,66,30)};
			this.chartControl1.Palette = ChartColorPalette.Custom ;

			this.chartControl1.Model.ColorModel.CustomColors = color;
			this.chartControl1.Palette = ChartColorPalette.Custom ;

			//this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(185,new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, Color.LightBlue , Color.Azure));
			this.chartControl1.LegendPosition = ChartDock.Top;
			
			this.chartControl1.HidePartialLabels = true;
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.panel1 = new System.Windows.Forms.Panel();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// chartControl1
			// 
			this.chartControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.None, System.Drawing.Color.FromArgb(((System.Byte)(55)), ((System.Byte)(245)), ((System.Byte)(245)), ((System.Byte)(220))), System.Drawing.SystemColors.Control);
			this.chartControl1.Controls.Add(this.chartControl1.Legend);
			// 
			// chartControl1.Legend
			// 
			this.chartControl1.Legend.Font = new System.Drawing.Font("Verdana", 10F);
			this.chartControl1.Legend.ItemsShadowColor = System.Drawing.Color.Gray;
			this.chartControl1.Legend.Location = new System.Drawing.Point(451, 181);
			this.chartControl1.Legend.Name = "";
			this.chartControl1.Legend.TabIndex = 3;
			this.chartControl1.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.GridLineType.BackColor = System.Drawing.Color.Silver;
			this.chartControl1.PrimaryXAxis.GridLineType.ForeColor = System.Drawing.Color.Silver;
			this.chartControl1.PrimaryXAxis.LabelAligment = System.Drawing.StringAlignment.Center;
			this.chartControl1.PrimaryXAxis.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
			this.chartControl1.PrimaryYAxis.GridLineType.ForeColor = System.Drawing.Color.Silver;
			this.chartControl1.PrimaryYAxis.LabelAligment = System.Drawing.StringAlignment.Center;
			this.chartControl1.Size = new System.Drawing.Size(552, 352);
			this.chartControl1.TabIndex = 0;
			this.chartControl1.Text = "Essential Chart";
			this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.ChartRegionMouseDown += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionMouseDown);
			this.chartControl1.ChartRegionMouseHover += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartRegionMouseHover);
			this.chartControl1.ChartRegionMouseUp += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionMouseUp);
			this.chartControl1.ChartRegionMouseMove += new Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventHandler(this.chartControl1_ChartRegionMouseMove);
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel1.BackColor = System.Drawing.Color.White;
			this.panel1.Controls.Add(this.statusBar1);
			this.panel1.Location = new System.Drawing.Point(0, 352);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(552, 24);
			this.panel1.TabIndex = 2;
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 2);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(552, 22);
			this.statusBar1.TabIndex = 0;
			// 
			// toolTip1
			// 
			this.toolTip1.AutomaticDelay = 200;
			this.toolTip1.AutoPopDelay = 400;
			this.toolTip1.InitialDelay = 200;
			this.toolTip1.ReshowDelay = 40;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 374);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.chartControl1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Sample";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChartData();
		}

		protected void InitializeChartData()
		{
			ChartSeries series = this.chartControl1.Model.NewSeries("Series",ChartSeriesType.Line);
			series.Text = series.Name;

			series.Points.Add(0,0);
			series.Points.Add(1,2);
			series.Points.Add(3,2);
			series.Points.Add(5,0);
			series.Points.Add(6,4);
			series.Points.Add(7,5);
			series.ShowTicks = true;
			series.Style.HighlightOnMouseOver = true;
			series.Style.Symbol.Shape = ChartSymbolShape.Circle;
			series.Style.Symbol.Size = new Size(6,6);
			series.Style.Symbol.Color = Color.Red;
			chartControl1.ElementsSpacing = 0;
			this.chartControl1.PrimaryXAxis.RangePaddingType= ChartAxisRangePaddingType.None;
			this.chartControl1.PrimaryYAxis.RangePaddingType= ChartAxisRangePaddingType.None;

			this.chartControl1.Series.Add(series);
			xmin = this.chartControl1.PrimaryXAxis.Range.Min;
			ymax = this.chartControl1.PrimaryYAxis.Range.Max;
			ymin = this.chartControl1.PrimaryYAxis.Range.Min;
			xmax = this.chartControl1.PrimaryXAxis.Range.Max;
		}

		private void chartControl1_ChartRegionMouseDown(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			if(e.Region.IsChartPoint)
			{
				this.isDragging = true;
				this.currentRegion = e.Region;
				string text = "Selected Point is: "+e.Region.PointIndex.ToString();
				this.statusBar1.Text = text.ToString();
				toolTip1.SetToolTip(chartControl1, text.ToString());
			}
		}

		private void chartControl1_ChartRegionMouseUp(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			if(this.isDragging)
			{
				this.chartControl1.Series[0].Points[this.currentRegion.PointIndex].YValues[0] = GetYValueForScreenPoint(Control.MousePosition);
				this.chartControl1.Series[0].Points[this.currentRegion.PointIndex].X = GetXValueForScreenPoint(Control.MousePosition);
				this.isDragging = false;
				this.currentRegion = null;
			}
		}

		private double GetXValueForScreenPoint(Point screenPoint)
		{
			chartAreaPointX = ConvertScreenPointToChartAreaPoint(Control.MousePosition);//Screen Coordinates to ChartArea coordinates

			Point axisStartPoint = this.chartControl1.GetChartAreaCoordinates(xmin,ymin);
			Point axisEndPoint = this.chartControl1.GetChartAreaCoordinates(xmax,ymin);
			Point axisZeroPoint = this.chartControl1.GetChartAreaCoordinates(0,ymin);

			// Double range
			double range = xmax - 0;

			// Pixel lengths
			double fullLength = axisEndPoint.X - axisStartPoint.X;
			double length = axisEndPoint.X - axisZeroPoint.X;
			double axisOrigin = this.chartControl1.ChartArea.ClientRectangle.Width - fullLength - this.chartControl1.ChartAreaMargins.Right;
			double lineX = chartAreaPointX.X - axisOrigin - axisZeroPoint.X;

			double returnVal = lineX/length * range;
			return returnVal;
		}

		private double GetYValueForScreenPoint(Point screenPoint)
		{
			//Screen Coordinates to ChartArea coordinates
			chartAreaPointY = ConvertScreenPointToChartAreaPoint(Control.MousePosition);

			Point axisStartPoint = this.chartControl1.GetChartAreaCoordinates(xmin,ymin);
			Point axisEndPoint = this.chartControl1.GetChartAreaCoordinates(xmin,ymax);
			Point axisZeroPoint = this.chartControl1.GetChartAreaCoordinates(0,ymin);

			// Double range
			double range = ymax - 0;

			// Pixel lengths
			double fullLength = axisEndPoint.Y - axisStartPoint.Y;
			double length = axisEndPoint.Y - axisZeroPoint.Y;
			double axisOrigin = this.chartControl1.ChartArea.ClientRectangle.Height + fullLength;
			double lineY = chartAreaPointY.Y - axisZeroPoint.Y;

			double returnVal = lineY/length * range;
			return returnVal;
		}

		private Point ConvertScreenPointToChartAreaPoint(Point screenPoint)
		{
			Rectangle chartAreaRectangle = this.chartControl1.ChartArea.ClientRectangle;

			//We cant directly convert a Screen Point to Chart Area Coordinates
			//This converts the point in screen coordinates to chartcontrol coordinates
			Point ccp = this.chartControl1.PointToClient(screenPoint);

			//This converts the chart point into chartarea coordinates
			Point cap = new Point(ccp.X - chartAreaRectangle.X, ccp.Y - chartAreaRectangle.Y);

			return cap;
		}

		private void chartRegionMouseHover(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			if(e.Region.IsChartPoint)
			{
				if(!isDragging)
				{
					this.Cursor = Cursors.Cross;
				}
				double newX = Math.Round(GetXValueForScreenPoint(Control.MousePosition),2);
				double newY = Math.Round(GetYValueForScreenPoint(Control.MousePosition),2);
				toolTip1.SetToolTip(chartControl1, newX +", "+newY);
			}
			else
			{
				if(this.Cursor != Cursors.Default && !this.isDragging)
				{
					this.Cursor = Cursors.Default;
				}
			}
		}

		private void chartControl1_ChartRegionMouseMove(object sender, Syncfusion.Windows.Forms.Chart.ChartRegionMouseEventArgs e)
		{
			if(this.isDragging)
			{
				this.chartControl1.Series[0].Points[this.currentRegion.PointIndex].X = GetXValueForScreenPoint(Control.MousePosition);
				this.chartControl1.Series[0].Points[this.currentRegion.PointIndex].YValues[0] = GetYValueForScreenPoint(Control.MousePosition);
				double newX = Math.Round(GetXValueForScreenPoint(Control.MousePosition),2) ;
				double newY = Math.Round(GetYValueForScreenPoint(Control.MousePosition),2) ;
				toolTip1.SetToolTip(chartControl1, newX +", "+newY);
				//this.chartControl1.Redraw(true);
				this.chartControl1.Refresh();
			}
		}

	}
}
